/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM mozISqlRequest.idl
 */

#ifndef __gen_mozISqlRequest_h__
#define __gen_mozISqlRequest_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class mozISqlConnection; /* forward declaration */

class mozISqlRequestObserver; /* forward declaration */

class mozISqlResult; /* forward declaration */


/* starting interface:    mozISqlRequest */
#define MOZISQLREQUEST_IID_STR "f67cb817-5e07-49ff-aacc-5c80585c5031"

#define MOZISQLREQUEST_IID \
  {0xf67cb817, 0x5e07, 0x49ff, \
    { 0xaa, 0xcc, 0x5c, 0x80, 0x58, 0x5c, 0x50, 0x31 }}

/**
 * A request interface used during an asynchronous SQL query or update operation.
 *
 * @status UNDER_REVIEW
 */
class NS_NO_VTABLE mozISqlRequest : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(MOZISQLREQUEST_IID)

  /**
   * The most recent error message.
   */
  /* readonly attribute AString errorMessage; */
  NS_IMETHOD GetErrorMessage(nsAString & aErrorMessage) = 0;

  /**
   * The result of the operation.
   */
  /* readonly attribute mozISqlResult result; */
  NS_IMETHOD GetResult(mozISqlResult * *aResult) = 0;

  /**
   * The number of rows that were affected during an update.
   */
  /* readonly attribute long affectedRows; */
  NS_IMETHOD GetAffectedRows(PRInt32 *aAffectedRows) = 0;

  /**
   * The ID of the most recently added record.
   */
  /* readonly attribute long lastID; */
  NS_IMETHOD GetLastID(PRInt32 *aLastID) = 0;

  /**
   * The SQL query
   */
  /* readonly attribute AString query; */
  NS_IMETHOD GetQuery(nsAString & aQuery) = 0;

  /**
   * The context passed to the connection's asyncExecuteQuery or
   * asyncExecuteUpdate method.
   */
  /* readonly attribute nsISupports ctxt; */
  NS_IMETHOD GetCtxt(nsISupports * *aCtxt) = 0;

  /**
   * The observer that listens for when the request is finished.
   * Methods of the observer should be called by the request.
   */
  /* readonly attribute mozISqlRequestObserver observer; */
  NS_IMETHOD GetObserver(mozISqlRequestObserver * *aObserver) = 0;

  /**
   * Status codes
   */
  enum { STATUS_NONE = 0 };

  enum { STATUS_EXECUTED = 1 };

  enum { STATUS_COMPLETE = 2 };

  enum { STATUS_ERROR = 3 };

  enum { STATUS_CANCELLED = 4 };

  /**
   * The status of the request.
   */
  /* readonly attribute long status; */
  NS_IMETHOD GetStatus(PRInt32 *aStatus) = 0;

  /**
   * Cancels the operation.
   */
  /* void cancel (); */
  NS_IMETHOD Cancel(void) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_MOZISQLREQUEST \
  NS_IMETHOD GetErrorMessage(nsAString & aErrorMessage); \
  NS_IMETHOD GetResult(mozISqlResult * *aResult); \
  NS_IMETHOD GetAffectedRows(PRInt32 *aAffectedRows); \
  NS_IMETHOD GetLastID(PRInt32 *aLastID); \
  NS_IMETHOD GetQuery(nsAString & aQuery); \
  NS_IMETHOD GetCtxt(nsISupports * *aCtxt); \
  NS_IMETHOD GetObserver(mozISqlRequestObserver * *aObserver); \
  NS_IMETHOD GetStatus(PRInt32 *aStatus); \
  NS_IMETHOD Cancel(void); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_MOZISQLREQUEST(_to) \
  NS_IMETHOD GetErrorMessage(nsAString & aErrorMessage) { return _to GetErrorMessage(aErrorMessage); } \
  NS_IMETHOD GetResult(mozISqlResult * *aResult) { return _to GetResult(aResult); } \
  NS_IMETHOD GetAffectedRows(PRInt32 *aAffectedRows) { return _to GetAffectedRows(aAffectedRows); } \
  NS_IMETHOD GetLastID(PRInt32 *aLastID) { return _to GetLastID(aLastID); } \
  NS_IMETHOD GetQuery(nsAString & aQuery) { return _to GetQuery(aQuery); } \
  NS_IMETHOD GetCtxt(nsISupports * *aCtxt) { return _to GetCtxt(aCtxt); } \
  NS_IMETHOD GetObserver(mozISqlRequestObserver * *aObserver) { return _to GetObserver(aObserver); } \
  NS_IMETHOD GetStatus(PRInt32 *aStatus) { return _to GetStatus(aStatus); } \
  NS_IMETHOD Cancel(void) { return _to Cancel(); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_MOZISQLREQUEST(_to) \
  NS_IMETHOD GetErrorMessage(nsAString & aErrorMessage) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetErrorMessage(aErrorMessage); } \
  NS_IMETHOD GetResult(mozISqlResult * *aResult) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetResult(aResult); } \
  NS_IMETHOD GetAffectedRows(PRInt32 *aAffectedRows) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetAffectedRows(aAffectedRows); } \
  NS_IMETHOD GetLastID(PRInt32 *aLastID) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetLastID(aLastID); } \
  NS_IMETHOD GetQuery(nsAString & aQuery) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetQuery(aQuery); } \
  NS_IMETHOD GetCtxt(nsISupports * *aCtxt) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetCtxt(aCtxt); } \
  NS_IMETHOD GetObserver(mozISqlRequestObserver * *aObserver) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetObserver(aObserver); } \
  NS_IMETHOD GetStatus(PRInt32 *aStatus) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetStatus(aStatus); } \
  NS_IMETHOD Cancel(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->Cancel(); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public mozISqlRequest
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_MOZISQLREQUEST

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, mozISqlRequest)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* readonly attribute AString errorMessage; */
NS_IMETHODIMP _MYCLASS_::GetErrorMessage(nsAString & aErrorMessage)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute mozISqlResult result; */
NS_IMETHODIMP _MYCLASS_::GetResult(mozISqlResult * *aResult)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute long affectedRows; */
NS_IMETHODIMP _MYCLASS_::GetAffectedRows(PRInt32 *aAffectedRows)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute long lastID; */
NS_IMETHODIMP _MYCLASS_::GetLastID(PRInt32 *aLastID)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString query; */
NS_IMETHODIMP _MYCLASS_::GetQuery(nsAString & aQuery)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsISupports ctxt; */
NS_IMETHODIMP _MYCLASS_::GetCtxt(nsISupports * *aCtxt)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute mozISqlRequestObserver observer; */
NS_IMETHODIMP _MYCLASS_::GetObserver(mozISqlRequestObserver * *aObserver)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute long status; */
NS_IMETHODIMP _MYCLASS_::GetStatus(PRInt32 *aStatus)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void cancel (); */
NS_IMETHODIMP _MYCLASS_::Cancel()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_mozISqlRequest_h__ */
