/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM mozISqlRequestObserver.idl
 */

#ifndef __gen_mozISqlRequestObserver_h__
#define __gen_mozISqlRequestObserver_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class mozISqlRequest; /* forward declaration */


/* starting interface:    mozISqlRequestObserver */
#define MOZISQLREQUESTOBSERVER_IID_STR "9e950bc0-e252-41ef-ac6f-3e3c4acd9dd8"

#define MOZISQLREQUESTOBSERVER_IID \
  {0x9e950bc0, 0xe252, 0x41ef, \
    { 0xac, 0x6f, 0x3e, 0x3c, 0x4a, 0xcd, 0x9d, 0xd8 }}

/**
 * This observer interface is used to listen to asynchronous SQL query or
 * update requests.
 *
 * @status UNDER_REVIEW
 */
class NS_NO_VTABLE mozISqlRequestObserver : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(MOZISQLREQUESTOBSERVER_IID)

  /**
   * This method will be called when the request is started.
   *
   * @param aRequest the request that has started
   * @param aContext a context that was supplied in the query/update call
   */
  /* void onStartRequest (in mozISqlRequest aRequest, in nsISupports aContext); */
  NS_IMETHOD OnStartRequest(mozISqlRequest *aRequest, nsISupports *aContext) = 0;

  /**
   * This method will be called when the request has finished. This function
   * will be called in both success and error cases.
   *
   * @param aRequest the request that has started
   * @param aContext a context that was supplied in the query/update call
   */
  /* void onStopRequest (in mozISqlRequest aRequest, in nsISupports aContext); */
  NS_IMETHOD OnStopRequest(mozISqlRequest *aRequest, nsISupports *aContext) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_MOZISQLREQUESTOBSERVER \
  NS_IMETHOD OnStartRequest(mozISqlRequest *aRequest, nsISupports *aContext); \
  NS_IMETHOD OnStopRequest(mozISqlRequest *aRequest, nsISupports *aContext); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_MOZISQLREQUESTOBSERVER(_to) \
  NS_IMETHOD OnStartRequest(mozISqlRequest *aRequest, nsISupports *aContext) { return _to OnStartRequest(aRequest, aContext); } \
  NS_IMETHOD OnStopRequest(mozISqlRequest *aRequest, nsISupports *aContext) { return _to OnStopRequest(aRequest, aContext); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_MOZISQLREQUESTOBSERVER(_to) \
  NS_IMETHOD OnStartRequest(mozISqlRequest *aRequest, nsISupports *aContext) { return !_to ? NS_ERROR_NULL_POINTER : _to->OnStartRequest(aRequest, aContext); } \
  NS_IMETHOD OnStopRequest(mozISqlRequest *aRequest, nsISupports *aContext) { return !_to ? NS_ERROR_NULL_POINTER : _to->OnStopRequest(aRequest, aContext); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public mozISqlRequestObserver
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_MOZISQLREQUESTOBSERVER

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, mozISqlRequestObserver)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* void onStartRequest (in mozISqlRequest aRequest, in nsISupports aContext); */
NS_IMETHODIMP _MYCLASS_::OnStartRequest(mozISqlRequest *aRequest, nsISupports *aContext)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void onStopRequest (in mozISqlRequest aRequest, in nsISupports aContext); */
NS_IMETHODIMP _MYCLASS_::OnStopRequest(mozISqlRequest *aRequest, nsISupports *aContext)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_mozISqlRequestObserver_h__ */
