/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM mozISqlResultEnumerator.idl
 */

#ifndef __gen_mozISqlResultEnumerator_h__
#define __gen_mozISqlResultEnumerator_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIVariant; /* forward declaration */


/* starting interface:    mozISqlResultEnumerator */
#define MOZISQLRESULTENUMERATOR_IID_STR "dcc0d29e-2b44-460e-b39f-89121ff8b963"

#define MOZISQLRESULTENUMERATOR_IID \
  {0xdcc0d29e, 0x2b44, 0x460e, \
    { 0xb3, 0x9f, 0x89, 0x12, 0x1f, 0xf8, 0xb9, 0x63 }}

/**
 * This interface is used to get the results from an SQL query.
 * The enumerator uses a row pointer which can be adjusted with
 * the next and previous methods. Other methods operate only on
 * the row selected by the pointer.
 *
 * The row pointer starts just before the first row, so you should
 * always call the next method once before attempting to read row
 * data.
 *
 * @status UNDER_DEVELOPMENT
 */
class NS_NO_VTABLE mozISqlResultEnumerator : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(MOZISQLRESULTENUMERATOR_IID)

  /**
   * The most recent error message.
   */
  /* readonly attribute AString errorMessage; */
  NS_IMETHOD GetErrorMessage(nsAString & aErrorMessage) = 0;

  /**
   * Moves the row pointer to the next row in the results.
   * Returns true if there is a next row and false if there are
   * no more rows.
   *
   * @return               false if there are no more rows
   */
  /* boolean next (); */
  NS_IMETHOD Next(PRBool *_retval) = 0;

  /**
   * Moves the row pointer to the previous row in the results.
   * Returns true if there is a previous row.
   *
   * @return               false if there are no previous rows
   */
  /* boolean previous (); */
  NS_IMETHOD Previous(PRBool *_retval) = 0;

  /**
   * Moves the row pointer to just before the first row.
   */
  /* void beforeFirst (); */
  NS_IMETHOD BeforeFirst(void) = 0;

  /**
   * Moves the row pointer to the first row.
   */
  /* void first (); */
  NS_IMETHOD First(void) = 0;

  /**
   * Moves the row pointer to the last row.
   */
  /* void last (); */
  NS_IMETHOD Last(void) = 0;

  /**
   * Moves the row pointer by a number relative to the current row.
   * An error occurs if this causes the row pointer to extend past
   * the last row. This method may also be used to move the row pointer
   * back by using a negative value.
   *
   * @param aRowIndex      aRowIndex the number of rows to move by
   */
  /* void relative (in long aRows); */
  NS_IMETHOD Relative(PRInt32 aRows) = 0;

  /**
   * Moves the row pointer to a specific row. An error occurs if the index
   * is after the last row.
   *
   * @param aRowIndex      the index of the row to move to
   */
  /* void absolute (in long aRowIndex); */
  NS_IMETHOD Absolute(PRInt32 aRowIndex) = 0;

  /**
   * Returns true if the value at the specified column in the current row
   * is null.
   *
   * @param aColumnIndex   the column to retrieve
   * @return               true if the value is null
   */
  /* boolean isNull (in long aColumnIndex); */
  NS_IMETHOD IsNull(PRInt32 aColumnIndex, PRBool *_retval) = 0;

  /**
   * Returns the value at the specified column in the current row as a variant.
   *
   * @param aColumnIndex   the column to retrieve
   * @return               the value as a variant
   */
  /* nsIVariant getVariant (in long aColumnIndex); */
  NS_IMETHOD GetVariant(PRInt32 aColumnIndex, nsIVariant **_retval) = 0;

  /**
   * Returns the value at the specified column in the current row as a string.
   * An error occurs if the value is not a string type.
   *
   * @param aColumnIndex   the column to retrieve
   * @return               the string value
   */
  /* AString getString (in long aColumnIndex); */
  NS_IMETHOD GetString(PRInt32 aColumnIndex, nsAString & _retval) = 0;

  /**
   * Returns the value at the specified column in the current row as an
   * integer. An error occurs if the value is not a integer type.
   *
   * @param aColumnIndex   the column to retrieve
   * @return               the integer value
   */
  /* long getInt (in long aColumnIndex); */
  NS_IMETHOD GetInt(PRInt32 aColumnIndex, PRInt32 *_retval) = 0;

  /**
   * Returns the value at the specified column in the current row as a
   * float. An error occurs if the value is not a float type.
   *
   * @param aColumnIndex   the column to retrieve
   * @return               the float value
   */
  /* float getFloat (in long aColumnIndex); */
  NS_IMETHOD GetFloat(PRInt32 aColumnIndex, float *_retval) = 0;

  /**
   * Returns the value at the specified column in the current row as a
   * decimal. An error occurs if the value is not a decimal type.
   *
   * @param aColumnIndex   the column to retrieve
   * @return               the decimal value
   */
  /* float getDecimal (in long aColumnIndex); */
  NS_IMETHOD GetDecimal(PRInt32 aColumnIndex, float *_retval) = 0;

  /**
   * Returns the value at the specified column in the current row as a date.
   * An error occurs if the value is not a date type.
   *
   * @param aColumnIndex   the column to retrieve
   * @return               the date value
   */
  /* long long getDate (in long aColumnIndex); */
  NS_IMETHOD GetDate(PRInt32 aColumnIndex, PRInt64 *_retval) = 0;

  /**
   * Returns the value at the specified column in the current row as a
   * boolean. An error occurs if the value is not a boolean type.
   *
   * @param aColumnIndex   the column to retrieve
   * @return               the boolean value
   */
  /* boolean getBool (in long aColumnIndex); */
  NS_IMETHOD GetBool(PRInt32 aColumnIndex, PRBool *_retval) = 0;

  /**
   * Sets the value at the specified column in the current row to null.
   * Changes are not committed until either the insertRow or updateRow method
   * is called.
   *
   * @param aColumnIndex   the column to modify
   */
  /* void setNull (in long aColumnIndex); */
  NS_IMETHOD SetNull(PRInt32 aColumnIndex) = 0;

  /**
   * Sets the value at the specified column in the current row to the
   * default value for that column. Changes are not committed until either the
   * insertRow or updateRow method is called.
   *
   * @param aColumnIndex   the column to modify
   */
  /* void setDefault (in long aColumnIndex); */
  NS_IMETHOD SetDefault(PRInt32 aColumnIndex) = 0;

  /**
   * Sets the value at the specified column in the current row to its original
   * value. The row may be changed with the various setX methods and then
   * commited with updateRow.
   *
   * @param aColumnIndex   the column to modify
   */
  /* void copy (in long aColumnIndex); */
  NS_IMETHOD Copy(PRInt32 aColumnIndex) = 0;

  /**
   * Sets the value at the specified column in the current row to a variant.
   * Changes are not committed until either the insertRow or updateRow method
   * is called.
   *
   * @param aColumnIndex   the column to modify
   * @param aValue         the value to assign
   */
  /* void setVariant (in long aColumnIndex, in nsIVariant aValue); */
  NS_IMETHOD SetVariant(PRInt32 aColumnIndex, nsIVariant *aValue) = 0;

  /**
   * Sets the value at the specified column in the current row to a string.
   * Changes are not committed until either the insertRow or updateRow method
   * is called.
   *
   * @param aColumnIndex   the column to modify
   * @param aValue         the value to assign
   */
  /* void setString (in long aColumnIndex, in AString aValue); */
  NS_IMETHOD SetString(PRInt32 aColumnIndex, const nsAString & aValue) = 0;

  /**
   * Sets the value at the specified column in the current row to an integer.
   * Changes are not committed until either the insertRow or updateRow method
   * is called.
   *
   * @param aColumnIndex   the column to modify
   * @param aValue         the value to assign
   */
  /* void setInt (in long aColumnIndex, in long aValue); */
  NS_IMETHOD SetInt(PRInt32 aColumnIndex, PRInt32 aValue) = 0;

  /**
   * Sets the value at the specified column in the current row to a float.
   * Changes are not committed until either the insertRow or updateRow method
   * is called.
   *
   * @param aColumnIndex   the column to modify
   * @param aValue         the value to assign
   */
  /* void setFloat (in long aColumnIndex, in float aValue); */
  NS_IMETHOD SetFloat(PRInt32 aColumnIndex, float aValue) = 0;

  /**
   * Sets the value at the specified column in the current row to a decimal.
   * Changes are not committed until either the insertRow or updateRow method
   * is called.
   *
   * @param aColumnIndex   the column to modify
   * @param aValue         the value to assign
   */
  /* void setDecimal (in long aColumnIndex, in float aValue); */
  NS_IMETHOD SetDecimal(PRInt32 aColumnIndex, float aValue) = 0;

  /**
   * Sets the value at the specified column in the current row to a date.
   * Changes are not committed until either the insertRow or updateRow method
   * is called.
   *
   * @param aColumnIndex   the column to modify
   * @param aValue         the value to assign
   */
  /* void setDate (in long aColumnIndex, in long long aValue); */
  NS_IMETHOD SetDate(PRInt32 aColumnIndex, PRInt64 aValue) = 0;

  /**
   * Sets the value at the specified column in the current row to a boolean.
   * Changes are not committed until either the insertRow or updateRow method
   * is called.
   *
   * @param aColumnIndex   the column to modify
   * @param aValue         the value to assign
   */
  /* void setBool (in long aColumnIndex, in boolean aValue); */
  NS_IMETHOD SetBool(PRInt32 aColumnIndex, PRBool aValue) = 0;

  /**
   * Sets the value of the cells in all columns in the current row to null.
   * This is equivalent to calling setNullValue for every column.
   */
  /* void setNullValues (); */
  NS_IMETHOD SetNullValues(void) = 0;

  /**
   * Sets the value of the cells in all columns in the current row to the
   * default values for the columns. This is equivalent to calling
   * setDefaultValue for every column.
   */
  /* void setDefaultValues (); */
  NS_IMETHOD SetDefaultValues(void) = 0;

  /**
   * Sets the values of all of the cells in the current row to their original
   * values. The row may be changed with the various set methods and then
   * commited with updateRow. This method is equivalent to calling the copy
   * method for each column.
   */
  /* void copyValues (); */
  NS_IMETHOD CopyValues(void) = 0;

  /**
   * Returns true if inserts are allowed.
   *
   * @return               true if inserts are allowed
   */
  /* boolean canInsert (); */
  NS_IMETHOD CanInsert(PRBool *_retval) = 0;

  /**
   * Returns true if updates are allowed.
   *
   * @return               true if updates are allowed
   */
  /* boolean canUpdate (); */
  NS_IMETHOD CanUpdate(PRBool *_retval) = 0;

  /**
   * Returns true if deletes are allowed.
   *
   * @return               true if deletes are allowed
   */
  /* boolean canDelete (); */
  NS_IMETHOD CanDelete(PRBool *_retval) = 0;

  /**
   * Inserts a row using the data assigned using the various setX methods.
   * The row was inserted successfully if 0 or 1 is returned, however if 0
   * is returned, the row does not satisfy the where condition of the result
   * (that is, it doesn't belong in the result enumerator) and does not need
   * to be displayed.
   *
   * @return               1 if the row was inserted, 0 if the row was
   *                       inserted but does not fit the condition, or -1
   *                       if an error occured.
   */
  /* long insertRow (); */
  NS_IMETHOD InsertRow(PRInt32 *_retval) = 0;

  /**
   * Updates the current row using the data assigned using the various setX
   * methods. The row was inserted successfully if 0 or 1 is returned, however
   * if 0 is returned, the row does not satisfy the where condition of the
   * result and does not need to be displayed.
   *
   * @return               1 if the row was updated, 0 if the row was updated
   *                       but does not fit the condition, or -1 if an error
   *                       occured.
   */
  /* long updateRow (); */
  NS_IMETHOD UpdateRow(PRInt32 *_retval) = 0;

  /**
   * Deletes the current row.
   *
   * @return               1 if the row was deleted or -1 if an error occured.
   */
  /* long deleteRow (); */
  NS_IMETHOD DeleteRow(PRInt32 *_retval) = 0;

  /**
   * Holds the SQL condition clause.
   */
  /* readonly attribute AString currentCondition; */
  NS_IMETHOD GetCurrentCondition(nsAString & aCurrentCondition) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_MOZISQLRESULTENUMERATOR \
  NS_IMETHOD GetErrorMessage(nsAString & aErrorMessage); \
  NS_IMETHOD Next(PRBool *_retval); \
  NS_IMETHOD Previous(PRBool *_retval); \
  NS_IMETHOD BeforeFirst(void); \
  NS_IMETHOD First(void); \
  NS_IMETHOD Last(void); \
  NS_IMETHOD Relative(PRInt32 aRows); \
  NS_IMETHOD Absolute(PRInt32 aRowIndex); \
  NS_IMETHOD IsNull(PRInt32 aColumnIndex, PRBool *_retval); \
  NS_IMETHOD GetVariant(PRInt32 aColumnIndex, nsIVariant **_retval); \
  NS_IMETHOD GetString(PRInt32 aColumnIndex, nsAString & _retval); \
  NS_IMETHOD GetInt(PRInt32 aColumnIndex, PRInt32 *_retval); \
  NS_IMETHOD GetFloat(PRInt32 aColumnIndex, float *_retval); \
  NS_IMETHOD GetDecimal(PRInt32 aColumnIndex, float *_retval); \
  NS_IMETHOD GetDate(PRInt32 aColumnIndex, PRInt64 *_retval); \
  NS_IMETHOD GetBool(PRInt32 aColumnIndex, PRBool *_retval); \
  NS_IMETHOD SetNull(PRInt32 aColumnIndex); \
  NS_IMETHOD SetDefault(PRInt32 aColumnIndex); \
  NS_IMETHOD Copy(PRInt32 aColumnIndex); \
  NS_IMETHOD SetVariant(PRInt32 aColumnIndex, nsIVariant *aValue); \
  NS_IMETHOD SetString(PRInt32 aColumnIndex, const nsAString & aValue); \
  NS_IMETHOD SetInt(PRInt32 aColumnIndex, PRInt32 aValue); \
  NS_IMETHOD SetFloat(PRInt32 aColumnIndex, float aValue); \
  NS_IMETHOD SetDecimal(PRInt32 aColumnIndex, float aValue); \
  NS_IMETHOD SetDate(PRInt32 aColumnIndex, PRInt64 aValue); \
  NS_IMETHOD SetBool(PRInt32 aColumnIndex, PRBool aValue); \
  NS_IMETHOD SetNullValues(void); \
  NS_IMETHOD SetDefaultValues(void); \
  NS_IMETHOD CopyValues(void); \
  NS_IMETHOD CanInsert(PRBool *_retval); \
  NS_IMETHOD CanUpdate(PRBool *_retval); \
  NS_IMETHOD CanDelete(PRBool *_retval); \
  NS_IMETHOD InsertRow(PRInt32 *_retval); \
  NS_IMETHOD UpdateRow(PRInt32 *_retval); \
  NS_IMETHOD DeleteRow(PRInt32 *_retval); \
  NS_IMETHOD GetCurrentCondition(nsAString & aCurrentCondition); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_MOZISQLRESULTENUMERATOR(_to) \
  NS_IMETHOD GetErrorMessage(nsAString & aErrorMessage) { return _to GetErrorMessage(aErrorMessage); } \
  NS_IMETHOD Next(PRBool *_retval) { return _to Next(_retval); } \
  NS_IMETHOD Previous(PRBool *_retval) { return _to Previous(_retval); } \
  NS_IMETHOD BeforeFirst(void) { return _to BeforeFirst(); } \
  NS_IMETHOD First(void) { return _to First(); } \
  NS_IMETHOD Last(void) { return _to Last(); } \
  NS_IMETHOD Relative(PRInt32 aRows) { return _to Relative(aRows); } \
  NS_IMETHOD Absolute(PRInt32 aRowIndex) { return _to Absolute(aRowIndex); } \
  NS_IMETHOD IsNull(PRInt32 aColumnIndex, PRBool *_retval) { return _to IsNull(aColumnIndex, _retval); } \
  NS_IMETHOD GetVariant(PRInt32 aColumnIndex, nsIVariant **_retval) { return _to GetVariant(aColumnIndex, _retval); } \
  NS_IMETHOD GetString(PRInt32 aColumnIndex, nsAString & _retval) { return _to GetString(aColumnIndex, _retval); } \
  NS_IMETHOD GetInt(PRInt32 aColumnIndex, PRInt32 *_retval) { return _to GetInt(aColumnIndex, _retval); } \
  NS_IMETHOD GetFloat(PRInt32 aColumnIndex, float *_retval) { return _to GetFloat(aColumnIndex, _retval); } \
  NS_IMETHOD GetDecimal(PRInt32 aColumnIndex, float *_retval) { return _to GetDecimal(aColumnIndex, _retval); } \
  NS_IMETHOD GetDate(PRInt32 aColumnIndex, PRInt64 *_retval) { return _to GetDate(aColumnIndex, _retval); } \
  NS_IMETHOD GetBool(PRInt32 aColumnIndex, PRBool *_retval) { return _to GetBool(aColumnIndex, _retval); } \
  NS_IMETHOD SetNull(PRInt32 aColumnIndex) { return _to SetNull(aColumnIndex); } \
  NS_IMETHOD SetDefault(PRInt32 aColumnIndex) { return _to SetDefault(aColumnIndex); } \
  NS_IMETHOD Copy(PRInt32 aColumnIndex) { return _to Copy(aColumnIndex); } \
  NS_IMETHOD SetVariant(PRInt32 aColumnIndex, nsIVariant *aValue) { return _to SetVariant(aColumnIndex, aValue); } \
  NS_IMETHOD SetString(PRInt32 aColumnIndex, const nsAString & aValue) { return _to SetString(aColumnIndex, aValue); } \
  NS_IMETHOD SetInt(PRInt32 aColumnIndex, PRInt32 aValue) { return _to SetInt(aColumnIndex, aValue); } \
  NS_IMETHOD SetFloat(PRInt32 aColumnIndex, float aValue) { return _to SetFloat(aColumnIndex, aValue); } \
  NS_IMETHOD SetDecimal(PRInt32 aColumnIndex, float aValue) { return _to SetDecimal(aColumnIndex, aValue); } \
  NS_IMETHOD SetDate(PRInt32 aColumnIndex, PRInt64 aValue) { return _to SetDate(aColumnIndex, aValue); } \
  NS_IMETHOD SetBool(PRInt32 aColumnIndex, PRBool aValue) { return _to SetBool(aColumnIndex, aValue); } \
  NS_IMETHOD SetNullValues(void) { return _to SetNullValues(); } \
  NS_IMETHOD SetDefaultValues(void) { return _to SetDefaultValues(); } \
  NS_IMETHOD CopyValues(void) { return _to CopyValues(); } \
  NS_IMETHOD CanInsert(PRBool *_retval) { return _to CanInsert(_retval); } \
  NS_IMETHOD CanUpdate(PRBool *_retval) { return _to CanUpdate(_retval); } \
  NS_IMETHOD CanDelete(PRBool *_retval) { return _to CanDelete(_retval); } \
  NS_IMETHOD InsertRow(PRInt32 *_retval) { return _to InsertRow(_retval); } \
  NS_IMETHOD UpdateRow(PRInt32 *_retval) { return _to UpdateRow(_retval); } \
  NS_IMETHOD DeleteRow(PRInt32 *_retval) { return _to DeleteRow(_retval); } \
  NS_IMETHOD GetCurrentCondition(nsAString & aCurrentCondition) { return _to GetCurrentCondition(aCurrentCondition); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_MOZISQLRESULTENUMERATOR(_to) \
  NS_IMETHOD GetErrorMessage(nsAString & aErrorMessage) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetErrorMessage(aErrorMessage); } \
  NS_IMETHOD Next(PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->Next(_retval); } \
  NS_IMETHOD Previous(PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->Previous(_retval); } \
  NS_IMETHOD BeforeFirst(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->BeforeFirst(); } \
  NS_IMETHOD First(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->First(); } \
  NS_IMETHOD Last(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->Last(); } \
  NS_IMETHOD Relative(PRInt32 aRows) { return !_to ? NS_ERROR_NULL_POINTER : _to->Relative(aRows); } \
  NS_IMETHOD Absolute(PRInt32 aRowIndex) { return !_to ? NS_ERROR_NULL_POINTER : _to->Absolute(aRowIndex); } \
  NS_IMETHOD IsNull(PRInt32 aColumnIndex, PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->IsNull(aColumnIndex, _retval); } \
  NS_IMETHOD GetVariant(PRInt32 aColumnIndex, nsIVariant **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetVariant(aColumnIndex, _retval); } \
  NS_IMETHOD GetString(PRInt32 aColumnIndex, nsAString & _retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetString(aColumnIndex, _retval); } \
  NS_IMETHOD GetInt(PRInt32 aColumnIndex, PRInt32 *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetInt(aColumnIndex, _retval); } \
  NS_IMETHOD GetFloat(PRInt32 aColumnIndex, float *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetFloat(aColumnIndex, _retval); } \
  NS_IMETHOD GetDecimal(PRInt32 aColumnIndex, float *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDecimal(aColumnIndex, _retval); } \
  NS_IMETHOD GetDate(PRInt32 aColumnIndex, PRInt64 *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDate(aColumnIndex, _retval); } \
  NS_IMETHOD GetBool(PRInt32 aColumnIndex, PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetBool(aColumnIndex, _retval); } \
  NS_IMETHOD SetNull(PRInt32 aColumnIndex) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetNull(aColumnIndex); } \
  NS_IMETHOD SetDefault(PRInt32 aColumnIndex) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetDefault(aColumnIndex); } \
  NS_IMETHOD Copy(PRInt32 aColumnIndex) { return !_to ? NS_ERROR_NULL_POINTER : _to->Copy(aColumnIndex); } \
  NS_IMETHOD SetVariant(PRInt32 aColumnIndex, nsIVariant *aValue) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetVariant(aColumnIndex, aValue); } \
  NS_IMETHOD SetString(PRInt32 aColumnIndex, const nsAString & aValue) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetString(aColumnIndex, aValue); } \
  NS_IMETHOD SetInt(PRInt32 aColumnIndex, PRInt32 aValue) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetInt(aColumnIndex, aValue); } \
  NS_IMETHOD SetFloat(PRInt32 aColumnIndex, float aValue) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetFloat(aColumnIndex, aValue); } \
  NS_IMETHOD SetDecimal(PRInt32 aColumnIndex, float aValue) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetDecimal(aColumnIndex, aValue); } \
  NS_IMETHOD SetDate(PRInt32 aColumnIndex, PRInt64 aValue) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetDate(aColumnIndex, aValue); } \
  NS_IMETHOD SetBool(PRInt32 aColumnIndex, PRBool aValue) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetBool(aColumnIndex, aValue); } \
  NS_IMETHOD SetNullValues(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetNullValues(); } \
  NS_IMETHOD SetDefaultValues(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetDefaultValues(); } \
  NS_IMETHOD CopyValues(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->CopyValues(); } \
  NS_IMETHOD CanInsert(PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->CanInsert(_retval); } \
  NS_IMETHOD CanUpdate(PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->CanUpdate(_retval); } \
  NS_IMETHOD CanDelete(PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->CanDelete(_retval); } \
  NS_IMETHOD InsertRow(PRInt32 *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->InsertRow(_retval); } \
  NS_IMETHOD UpdateRow(PRInt32 *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->UpdateRow(_retval); } \
  NS_IMETHOD DeleteRow(PRInt32 *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->DeleteRow(_retval); } \
  NS_IMETHOD GetCurrentCondition(nsAString & aCurrentCondition) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetCurrentCondition(aCurrentCondition); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public mozISqlResultEnumerator
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_MOZISQLRESULTENUMERATOR

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, mozISqlResultEnumerator)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* readonly attribute AString errorMessage; */
NS_IMETHODIMP _MYCLASS_::GetErrorMessage(nsAString & aErrorMessage)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean next (); */
NS_IMETHODIMP _MYCLASS_::Next(PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean previous (); */
NS_IMETHODIMP _MYCLASS_::Previous(PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void beforeFirst (); */
NS_IMETHODIMP _MYCLASS_::BeforeFirst()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void first (); */
NS_IMETHODIMP _MYCLASS_::First()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void last (); */
NS_IMETHODIMP _MYCLASS_::Last()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void relative (in long aRows); */
NS_IMETHODIMP _MYCLASS_::Relative(PRInt32 aRows)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void absolute (in long aRowIndex); */
NS_IMETHODIMP _MYCLASS_::Absolute(PRInt32 aRowIndex)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean isNull (in long aColumnIndex); */
NS_IMETHODIMP _MYCLASS_::IsNull(PRInt32 aColumnIndex, PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIVariant getVariant (in long aColumnIndex); */
NS_IMETHODIMP _MYCLASS_::GetVariant(PRInt32 aColumnIndex, nsIVariant **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* AString getString (in long aColumnIndex); */
NS_IMETHODIMP _MYCLASS_::GetString(PRInt32 aColumnIndex, nsAString & _retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* long getInt (in long aColumnIndex); */
NS_IMETHODIMP _MYCLASS_::GetInt(PRInt32 aColumnIndex, PRInt32 *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* float getFloat (in long aColumnIndex); */
NS_IMETHODIMP _MYCLASS_::GetFloat(PRInt32 aColumnIndex, float *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* float getDecimal (in long aColumnIndex); */
NS_IMETHODIMP _MYCLASS_::GetDecimal(PRInt32 aColumnIndex, float *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* long long getDate (in long aColumnIndex); */
NS_IMETHODIMP _MYCLASS_::GetDate(PRInt32 aColumnIndex, PRInt64 *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean getBool (in long aColumnIndex); */
NS_IMETHODIMP _MYCLASS_::GetBool(PRInt32 aColumnIndex, PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void setNull (in long aColumnIndex); */
NS_IMETHODIMP _MYCLASS_::SetNull(PRInt32 aColumnIndex)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void setDefault (in long aColumnIndex); */
NS_IMETHODIMP _MYCLASS_::SetDefault(PRInt32 aColumnIndex)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void copy (in long aColumnIndex); */
NS_IMETHODIMP _MYCLASS_::Copy(PRInt32 aColumnIndex)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void setVariant (in long aColumnIndex, in nsIVariant aValue); */
NS_IMETHODIMP _MYCLASS_::SetVariant(PRInt32 aColumnIndex, nsIVariant *aValue)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void setString (in long aColumnIndex, in AString aValue); */
NS_IMETHODIMP _MYCLASS_::SetString(PRInt32 aColumnIndex, const nsAString & aValue)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void setInt (in long aColumnIndex, in long aValue); */
NS_IMETHODIMP _MYCLASS_::SetInt(PRInt32 aColumnIndex, PRInt32 aValue)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void setFloat (in long aColumnIndex, in float aValue); */
NS_IMETHODIMP _MYCLASS_::SetFloat(PRInt32 aColumnIndex, float aValue)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void setDecimal (in long aColumnIndex, in float aValue); */
NS_IMETHODIMP _MYCLASS_::SetDecimal(PRInt32 aColumnIndex, float aValue)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void setDate (in long aColumnIndex, in long long aValue); */
NS_IMETHODIMP _MYCLASS_::SetDate(PRInt32 aColumnIndex, PRInt64 aValue)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void setBool (in long aColumnIndex, in boolean aValue); */
NS_IMETHODIMP _MYCLASS_::SetBool(PRInt32 aColumnIndex, PRBool aValue)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void setNullValues (); */
NS_IMETHODIMP _MYCLASS_::SetNullValues()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void setDefaultValues (); */
NS_IMETHODIMP _MYCLASS_::SetDefaultValues()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void copyValues (); */
NS_IMETHODIMP _MYCLASS_::CopyValues()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean canInsert (); */
NS_IMETHODIMP _MYCLASS_::CanInsert(PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean canUpdate (); */
NS_IMETHODIMP _MYCLASS_::CanUpdate(PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean canDelete (); */
NS_IMETHODIMP _MYCLASS_::CanDelete(PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* long insertRow (); */
NS_IMETHODIMP _MYCLASS_::InsertRow(PRInt32 *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* long updateRow (); */
NS_IMETHODIMP _MYCLASS_::UpdateRow(PRInt32 *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* long deleteRow (); */
NS_IMETHODIMP _MYCLASS_::DeleteRow(PRInt32 *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString currentCondition; */
NS_IMETHODIMP _MYCLASS_::GetCurrentCondition(nsAString & aCurrentCondition)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_mozISqlResultEnumerator_h__ */
