/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM mozISqlService.idl
 */

#ifndef __gen_mozISqlService_h__
#define __gen_mozISqlService_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIRDFResource; /* forward declaration */

class nsISimpleEnumerator; /* forward declaration */

class mozISqlConnection; /* forward declaration */


/* starting interface:    mozISqlService */
#define MOZISQLSERVICE_IID_STR "1ceb35b7-daa8-4ce4-ac67-125fb17cb019"

#define MOZISQLSERVICE_IID \
  {0x1ceb35b7, 0xdaa8, 0x4ce4, \
    { 0xac, 0x67, 0x12, 0x5f, 0xb1, 0x7c, 0xb0, 0x19 }}

/**
 * The SQL service is used to construct direct connections to SQL-based
 * databases. The service maintains a set of aliases, one for each database
 * to connect to. Methods are provided for adding, retrieving and removing
 * aliases. Once an alias has been added, it is persistent, so it does not need
 * to be added again. The aliases are stored in user preferences.
 * Aliases are identfied using an RDF resource.
 *
 * Once an alias has been added, a connection may be opened to a database using
 * the RDF resource.
 *
 * @status UNDER_DEVELOPMENT
 */
class NS_NO_VTABLE mozISqlService : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(MOZISQLSERVICE_IID)

  /**
   * Holds the string message of the last error that occured when a connection
   * was opened.
   */
  /* readonly attribute AString errorMessage; */
  NS_IMETHOD GetErrorMessage(nsAString & aErrorMessage) = 0;

  /**
   * Add an alias for a database connection. An alias must be added before a
   * connection can be made.
   *
   * Different types of databases may be connected to using the |aType|
   * argument. For instance 'pgsql' or 'mysql'. When a connection is made, a
   * component of the form '@mozilla.org/sql/connection;1?type=<type>' will be
   * looked up using the component manager. This allows additional database
   * implementations to be provided separately of mozSQL.
   *
   * @param aName       human-readable name of the alias
   * @param aType       database type (such as pgsql)
   * @param aHostname   hostname for the database
   * @param aPort       port for the database
   * @param aDatabase   database name
   * @param aPriority   priority
   * @return            an RDF resource representing the alias
   */
  /* nsIRDFResource addAlias (in AString aName, in AString aType, in AString aHostname, in long aPort, in AString aDatabase, in long aPriority); */
  NS_IMETHOD AddAlias(const nsAString & aName, const nsAString & aType, const nsAString & aHostname, PRInt32 aPort, const nsAString & aDatabase, PRInt32 aPriority, nsIRDFResource **_retval) = 0;

  /**
   * Retrieves alias information. The out parameters are filled in with
   * the corresponding information.
   *
   * @param aAlias      the alias to retrieve
   * @param aName       human-readable name of the alias
   * @param aType       database type
   * @param aHostname   hostname of the database
   * @param aPort       port of the database
   * @param aDatabase   database name
   * @param aPriority   priority
   */
  /* void fetchAlias (in nsIRDFResource aAlias, out AString aName, out AString aType, out AString aHostname, out long aPort, out AString aDatabase, out long aPriority); */
  NS_IMETHOD FetchAlias(nsIRDFResource *aAlias, nsAString & aName, nsAString & aType, nsAString & aHostname, PRInt32 *aPort, nsAString & aDatabase, PRInt32 *aPriority) = 0;

  /**
   * Update the information of an alias that has already been added. The new
   * information replaces the old information.
   *
   *
   * @param aAlias      the alias to update
   * @param aName       human-readable name of the alias
   * @param aType       database type (such as pgsql)
   * @param aHostname   hostname for the database
   * @param aPort       port for the database
   * @param aDatabase   database name
   * @param aPriority   priority
   */
  /* void updateAlias (in nsIRDFResource aAlias, in AString aName, in AString aType, in AString aHostname, in long aPort, in AString aDatabase, in long aPriority); */
  NS_IMETHOD UpdateAlias(nsIRDFResource *aAlias, const nsAString & aName, const nsAString & aType, const nsAString & aHostname, PRInt32 aPort, const nsAString & aDatabase, PRInt32 aPriority) = 0;

  /**
   * Removes an alias that already exists.
   *
   * @param aAlias      the alias to remove
   */
  /* void removeAlias (in nsIRDFResource aAlias); */
  NS_IMETHOD RemoveAlias(nsIRDFResource *aAlias) = 0;

  /**
   * Get the alias resource with the given name.
   *
   * @param aName      the name of the alias to retrieve
   * @return           the RDF resource for the alias, or null if it doesn't exist.
   */
  /* nsIRDFResource getAlias (in AString aName); */
  NS_IMETHOD GetAlias(const nsAString & aName, nsIRDFResource **_retval) = 0;

  /**
   * Get the aliases with the given name.
   *
   * @param aName      the name of the aliases to retrieve
   * @return           an enumerator for the aliases
   */
  /* nsISimpleEnumerator getAliases (in AString aName); */
  NS_IMETHOD GetAliases(const nsAString & aName, nsISimpleEnumerator **_retval) = 0;

  /**
   * Retrieves an SQL connection to a database given its alias. If a
   * connection is already open, that connection is returned. Otherwise,
   * a new connection is opened and returned.
   *
   * @param aAlias      the alias to use to open a connection
   * @return            a connection
   */
  /* mozISqlConnection getConnection (in nsIRDFResource aAlias); */
  NS_IMETHOD GetConnection(nsIRDFResource *aAlias, mozISqlConnection **_retval) = 0;

  /**
   * Opens and returns a new connection to a database. The user will be
   * prompted for a username and password.
   *
   * @param aAlias      the alias to use to open a connection
   * @return            a newly opened connection
   */
  /* mozISqlConnection getNewConnection (in nsIRDFResource aAlias); */
  NS_IMETHOD GetNewConnection(nsIRDFResource *aAlias, mozISqlConnection **_retval) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_MOZISQLSERVICE \
  NS_IMETHOD GetErrorMessage(nsAString & aErrorMessage); \
  NS_IMETHOD AddAlias(const nsAString & aName, const nsAString & aType, const nsAString & aHostname, PRInt32 aPort, const nsAString & aDatabase, PRInt32 aPriority, nsIRDFResource **_retval); \
  NS_IMETHOD FetchAlias(nsIRDFResource *aAlias, nsAString & aName, nsAString & aType, nsAString & aHostname, PRInt32 *aPort, nsAString & aDatabase, PRInt32 *aPriority); \
  NS_IMETHOD UpdateAlias(nsIRDFResource *aAlias, const nsAString & aName, const nsAString & aType, const nsAString & aHostname, PRInt32 aPort, const nsAString & aDatabase, PRInt32 aPriority); \
  NS_IMETHOD RemoveAlias(nsIRDFResource *aAlias); \
  NS_IMETHOD GetAlias(const nsAString & aName, nsIRDFResource **_retval); \
  NS_IMETHOD GetAliases(const nsAString & aName, nsISimpleEnumerator **_retval); \
  NS_IMETHOD GetConnection(nsIRDFResource *aAlias, mozISqlConnection **_retval); \
  NS_IMETHOD GetNewConnection(nsIRDFResource *aAlias, mozISqlConnection **_retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_MOZISQLSERVICE(_to) \
  NS_IMETHOD GetErrorMessage(nsAString & aErrorMessage) { return _to GetErrorMessage(aErrorMessage); } \
  NS_IMETHOD AddAlias(const nsAString & aName, const nsAString & aType, const nsAString & aHostname, PRInt32 aPort, const nsAString & aDatabase, PRInt32 aPriority, nsIRDFResource **_retval) { return _to AddAlias(aName, aType, aHostname, aPort, aDatabase, aPriority, _retval); } \
  NS_IMETHOD FetchAlias(nsIRDFResource *aAlias, nsAString & aName, nsAString & aType, nsAString & aHostname, PRInt32 *aPort, nsAString & aDatabase, PRInt32 *aPriority) { return _to FetchAlias(aAlias, aName, aType, aHostname, aPort, aDatabase, aPriority); } \
  NS_IMETHOD UpdateAlias(nsIRDFResource *aAlias, const nsAString & aName, const nsAString & aType, const nsAString & aHostname, PRInt32 aPort, const nsAString & aDatabase, PRInt32 aPriority) { return _to UpdateAlias(aAlias, aName, aType, aHostname, aPort, aDatabase, aPriority); } \
  NS_IMETHOD RemoveAlias(nsIRDFResource *aAlias) { return _to RemoveAlias(aAlias); } \
  NS_IMETHOD GetAlias(const nsAString & aName, nsIRDFResource **_retval) { return _to GetAlias(aName, _retval); } \
  NS_IMETHOD GetAliases(const nsAString & aName, nsISimpleEnumerator **_retval) { return _to GetAliases(aName, _retval); } \
  NS_IMETHOD GetConnection(nsIRDFResource *aAlias, mozISqlConnection **_retval) { return _to GetConnection(aAlias, _retval); } \
  NS_IMETHOD GetNewConnection(nsIRDFResource *aAlias, mozISqlConnection **_retval) { return _to GetNewConnection(aAlias, _retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_MOZISQLSERVICE(_to) \
  NS_IMETHOD GetErrorMessage(nsAString & aErrorMessage) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetErrorMessage(aErrorMessage); } \
  NS_IMETHOD AddAlias(const nsAString & aName, const nsAString & aType, const nsAString & aHostname, PRInt32 aPort, const nsAString & aDatabase, PRInt32 aPriority, nsIRDFResource **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->AddAlias(aName, aType, aHostname, aPort, aDatabase, aPriority, _retval); } \
  NS_IMETHOD FetchAlias(nsIRDFResource *aAlias, nsAString & aName, nsAString & aType, nsAString & aHostname, PRInt32 *aPort, nsAString & aDatabase, PRInt32 *aPriority) { return !_to ? NS_ERROR_NULL_POINTER : _to->FetchAlias(aAlias, aName, aType, aHostname, aPort, aDatabase, aPriority); } \
  NS_IMETHOD UpdateAlias(nsIRDFResource *aAlias, const nsAString & aName, const nsAString & aType, const nsAString & aHostname, PRInt32 aPort, const nsAString & aDatabase, PRInt32 aPriority) { return !_to ? NS_ERROR_NULL_POINTER : _to->UpdateAlias(aAlias, aName, aType, aHostname, aPort, aDatabase, aPriority); } \
  NS_IMETHOD RemoveAlias(nsIRDFResource *aAlias) { return !_to ? NS_ERROR_NULL_POINTER : _to->RemoveAlias(aAlias); } \
  NS_IMETHOD GetAlias(const nsAString & aName, nsIRDFResource **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetAlias(aName, _retval); } \
  NS_IMETHOD GetAliases(const nsAString & aName, nsISimpleEnumerator **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetAliases(aName, _retval); } \
  NS_IMETHOD GetConnection(nsIRDFResource *aAlias, mozISqlConnection **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetConnection(aAlias, _retval); } \
  NS_IMETHOD GetNewConnection(nsIRDFResource *aAlias, mozISqlConnection **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetNewConnection(aAlias, _retval); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public mozISqlService
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_MOZISQLSERVICE

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, mozISqlService)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* readonly attribute AString errorMessage; */
NS_IMETHODIMP _MYCLASS_::GetErrorMessage(nsAString & aErrorMessage)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIRDFResource addAlias (in AString aName, in AString aType, in AString aHostname, in long aPort, in AString aDatabase, in long aPriority); */
NS_IMETHODIMP _MYCLASS_::AddAlias(const nsAString & aName, const nsAString & aType, const nsAString & aHostname, PRInt32 aPort, const nsAString & aDatabase, PRInt32 aPriority, nsIRDFResource **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void fetchAlias (in nsIRDFResource aAlias, out AString aName, out AString aType, out AString aHostname, out long aPort, out AString aDatabase, out long aPriority); */
NS_IMETHODIMP _MYCLASS_::FetchAlias(nsIRDFResource *aAlias, nsAString & aName, nsAString & aType, nsAString & aHostname, PRInt32 *aPort, nsAString & aDatabase, PRInt32 *aPriority)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void updateAlias (in nsIRDFResource aAlias, in AString aName, in AString aType, in AString aHostname, in long aPort, in AString aDatabase, in long aPriority); */
NS_IMETHODIMP _MYCLASS_::UpdateAlias(nsIRDFResource *aAlias, const nsAString & aName, const nsAString & aType, const nsAString & aHostname, PRInt32 aPort, const nsAString & aDatabase, PRInt32 aPriority)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void removeAlias (in nsIRDFResource aAlias); */
NS_IMETHODIMP _MYCLASS_::RemoveAlias(nsIRDFResource *aAlias)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIRDFResource getAlias (in AString aName); */
NS_IMETHODIMP _MYCLASS_::GetAlias(const nsAString & aName, nsIRDFResource **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsISimpleEnumerator getAliases (in AString aName); */
NS_IMETHODIMP _MYCLASS_::GetAliases(const nsAString & aName, nsISimpleEnumerator **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* mozISqlConnection getConnection (in nsIRDFResource aAlias); */
NS_IMETHODIMP _MYCLASS_::GetConnection(nsIRDFResource *aAlias, mozISqlConnection **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* mozISqlConnection getNewConnection (in nsIRDFResource aAlias); */
NS_IMETHODIMP _MYCLASS_::GetNewConnection(nsIRDFResource *aAlias, mozISqlConnection **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_mozISqlService_h__ */
