/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIXFormsControl.idl
 */

#ifndef __gen_nsIXFormsControl_h__
#define __gen_nsIXFormsControl_h__


#ifndef __gen_nsIXFormsContextControl_h__
#include "nsIXFormsContextControl.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIDOMNode; /* forward declaration */

class nsIDOMElement; /* forward declaration */

  #include "nsCOMArray.h"

/* starting interface:    nsIXFormsControl */
#define NS_IXFORMSCONTROL_IID_STR "8c84afe1-e071-4d45-b3da-c5aa93154343"

#define NS_IXFORMSCONTROL_IID \
  {0x8c84afe1, 0xe071, 0x4d45, \
    { 0xb3, 0xda, 0xc5, 0xaa, 0x93, 0x15, 0x43, 0x43 }}

/**
 * Interface implemented by all XForms form control classes.
 */
class NS_NO_VTABLE nsIXFormsControl : public nsIXFormsContextControl {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IXFORMSCONTROL_IID)

  /**
   * Tries to move focus to form control and returns true if succeeded.
   */
  /* boolean tryFocus (); */
  NS_IMETHOD TryFocus(PRBool *_retval) = 0;

  /**
   * The instance node that the control is bound to.
   */
  /* readonly attribute nsIDOMNode boundNode; */
  NS_IMETHOD GetBoundNode(nsIDOMNode * *aBoundNode) = 0;

  /**
   * Binds the control to the model. Only handles attaching to the model
   * (including reattaching from any old model).
   *
   * @note It can also set the boundNode, but does not do a proper node
   * binding, as in setting up dependencies, attaching index() listeners, etc.
   *
   * @param setBoundNode     Set boundNode too?
   */
  /* void bindToModel (in boolean setBoundNode); */
  NS_IMETHOD BindToModel(PRBool setBoundNode) = 0;

  /**
   * The instance nodes that the control depend on.
   *
   * In other words, all the instance nodes that could influence which node
   * the control is bound to (mBoundNode). For example:
   * If a node has @ref="/share[@owner = /me]", it depends on all /share
   * nodes, all @owner attributes on /share nodes, and all /me nodes.
   */
  /* readonly attribute nsCOMArrayPtr dependencies; */
  NS_IMETHOD GetDependencies(nsCOMArray<nsIDOMNode> * *aDependencies) = 0;

  /**
   * Get the element that should receive events for the control.
   *
   * @todo This should not be necessary, we should send directly to the
   * control (XXX)
   */
  /* readonly attribute nsIDOMElement element; */
  NS_IMETHOD GetElement(nsIDOMElement * *aElement) = 0;

  /** According to sec 4.1 in the spec, only certain controls are allowed to
   *  be targets of the interaction and notification events.  The controls
   *  that inherit from nsXFormsControlStub that SHOULDN'T get these events
   *  need to override IsEventTarget() and return PR_FALSE
   */
  /* boolean isEventTarget (); */
  NS_IMETHOD IsEventTarget(PRBool *_retval) = 0;

  /**
   * Is true when the control is getting its instance data node binding from a
   * model bind element, ie. it has a |bind| attribute.
   */
  /* readonly attribute boolean usesModelBinding; */
  NS_IMETHOD GetUsesModelBinding(PRBool *aUsesModelBinding) = 0;

  /**
   * These represent the default intrinsic states for controls when they are
   * enabled and disabled.
   */
  /* readonly attribute long defaultIntrinsicState; */
  NS_IMETHOD GetDefaultIntrinsicState(PRInt32 *aDefaultIntrinsicState) = 0;

  /* readonly attribute long disabledIntrinsicState; */
  NS_IMETHOD GetDisabledIntrinsicState(PRInt32 *aDisabledIntrinsicState) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIXFORMSCONTROL \
  NS_IMETHOD TryFocus(PRBool *_retval); \
  NS_IMETHOD GetBoundNode(nsIDOMNode * *aBoundNode); \
  NS_IMETHOD BindToModel(PRBool setBoundNode); \
  NS_IMETHOD GetDependencies(nsCOMArray<nsIDOMNode> * *aDependencies); \
  NS_IMETHOD GetElement(nsIDOMElement * *aElement); \
  NS_IMETHOD IsEventTarget(PRBool *_retval); \
  NS_IMETHOD GetUsesModelBinding(PRBool *aUsesModelBinding); \
  NS_IMETHOD GetDefaultIntrinsicState(PRInt32 *aDefaultIntrinsicState); \
  NS_IMETHOD GetDisabledIntrinsicState(PRInt32 *aDisabledIntrinsicState); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIXFORMSCONTROL(_to) \
  NS_IMETHOD TryFocus(PRBool *_retval) { return _to TryFocus(_retval); } \
  NS_IMETHOD GetBoundNode(nsIDOMNode * *aBoundNode) { return _to GetBoundNode(aBoundNode); } \
  NS_IMETHOD BindToModel(PRBool setBoundNode) { return _to BindToModel(setBoundNode); } \
  NS_IMETHOD GetDependencies(nsCOMArray<nsIDOMNode> * *aDependencies) { return _to GetDependencies(aDependencies); } \
  NS_IMETHOD GetElement(nsIDOMElement * *aElement) { return _to GetElement(aElement); } \
  NS_IMETHOD IsEventTarget(PRBool *_retval) { return _to IsEventTarget(_retval); } \
  NS_IMETHOD GetUsesModelBinding(PRBool *aUsesModelBinding) { return _to GetUsesModelBinding(aUsesModelBinding); } \
  NS_IMETHOD GetDefaultIntrinsicState(PRInt32 *aDefaultIntrinsicState) { return _to GetDefaultIntrinsicState(aDefaultIntrinsicState); } \
  NS_IMETHOD GetDisabledIntrinsicState(PRInt32 *aDisabledIntrinsicState) { return _to GetDisabledIntrinsicState(aDisabledIntrinsicState); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIXFORMSCONTROL(_to) \
  NS_IMETHOD TryFocus(PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->TryFocus(_retval); } \
  NS_IMETHOD GetBoundNode(nsIDOMNode * *aBoundNode) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetBoundNode(aBoundNode); } \
  NS_IMETHOD BindToModel(PRBool setBoundNode) { return !_to ? NS_ERROR_NULL_POINTER : _to->BindToModel(setBoundNode); } \
  NS_IMETHOD GetDependencies(nsCOMArray<nsIDOMNode> * *aDependencies) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDependencies(aDependencies); } \
  NS_IMETHOD GetElement(nsIDOMElement * *aElement) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetElement(aElement); } \
  NS_IMETHOD IsEventTarget(PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->IsEventTarget(_retval); } \
  NS_IMETHOD GetUsesModelBinding(PRBool *aUsesModelBinding) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetUsesModelBinding(aUsesModelBinding); } \
  NS_IMETHOD GetDefaultIntrinsicState(PRInt32 *aDefaultIntrinsicState) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDefaultIntrinsicState(aDefaultIntrinsicState); } \
  NS_IMETHOD GetDisabledIntrinsicState(PRInt32 *aDisabledIntrinsicState) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDisabledIntrinsicState(aDisabledIntrinsicState); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsXFormsControl : public nsIXFormsControl
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIXFORMSCONTROL

  nsXFormsControl();

private:
  ~nsXFormsControl();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsXFormsControl, nsIXFormsControl)

nsXFormsControl::nsXFormsControl()
{
  /* member initializers and constructor code */
}

nsXFormsControl::~nsXFormsControl()
{
  /* destructor code */
}

/* boolean tryFocus (); */
NS_IMETHODIMP nsXFormsControl::TryFocus(PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIDOMNode boundNode; */
NS_IMETHODIMP nsXFormsControl::GetBoundNode(nsIDOMNode * *aBoundNode)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void bindToModel (in boolean setBoundNode); */
NS_IMETHODIMP nsXFormsControl::BindToModel(PRBool setBoundNode)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsCOMArrayPtr dependencies; */
NS_IMETHODIMP nsXFormsControl::GetDependencies(nsCOMArray<nsIDOMNode> * *aDependencies)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIDOMElement element; */
NS_IMETHODIMP nsXFormsControl::GetElement(nsIDOMElement * *aElement)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean isEventTarget (); */
NS_IMETHODIMP nsXFormsControl::IsEventTarget(PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute boolean usesModelBinding; */
NS_IMETHODIMP nsXFormsControl::GetUsesModelBinding(PRBool *aUsesModelBinding)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute long defaultIntrinsicState; */
NS_IMETHODIMP nsXFormsControl::GetDefaultIntrinsicState(PRInt32 *aDefaultIntrinsicState)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute long disabledIntrinsicState; */
NS_IMETHODIMP nsXFormsControl::GetDisabledIntrinsicState(PRInt32 *aDisabledIntrinsicState)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIXFormsControl_h__ */
